// Autogenerated from Pigeon (v0.1.23), do not edit directly.
// See also: https://pub.dev/packages/pigeon
#import <Foundation/Foundation.h>
@protocol FlutterBinaryMessenger;
@class FlutterError;
@class FlutterStandardTypedData;

NS_ASSUME_NONNULL_BEGIN

@class FLTInitializeRequest;
@class FLTOAuthToken;
@class FLTGetHashKeyReply;
@class FLTAccessTokenInfo;
@class FLTBoolReply;
@class FLTVoidReply;
@class FLTUser;
@class FLTAccount;
@class FLTProfile;

@interface FLTInitializeRequest : NSObject
@property(nonatomic, copy, nullable) NSString * appKey;
@end

@interface FLTOAuthToken : NSObject
@property(nonatomic, copy, nullable) NSString * accessToken;
@property(nonatomic, strong, nullable) NSNumber * accessTokenExpiresAt;
@property(nonatomic, strong, nullable) NSNumber * expiresIn;
@property(nonatomic, copy, nullable) NSString * refreshToken;
@property(nonatomic, strong, nullable) NSNumber * refreshTokenExpiresAt;
@property(nonatomic, strong, nullable) NSNumber * refreshTokenExpiresIn;
@property(nonatomic, strong, nullable) NSArray * scopes;
@end

@interface FLTGetHashKeyReply : NSObject
@property(nonatomic, copy, nullable) NSString * haskHey;
@end

@interface FLTAccessTokenInfo : NSObject
@property(nonatomic, strong, nullable) NSNumber * id;
@property(nonatomic, strong, nullable) NSNumber * expiresIn;
@end

@interface FLTBoolReply : NSObject
@property(nonatomic, strong, nullable) NSNumber * value;
@end

@interface FLTVoidReply : NSObject
@property(nonatomic, strong, nullable) NSNumber * ignore;
@end

@interface FLTUser : NSObject
@property(nonatomic, strong, nullable) NSNumber * id;
@property(nonatomic, strong, nullable) NSDictionary * properties;
@property(nonatomic, strong, nullable) FLTAccount * kakaoAccount;
@property(nonatomic, copy, nullable) NSString * groupUserToken;
@property(nonatomic, strong, nullable) NSNumber * connectedAt;
@property(nonatomic, strong, nullable) NSNumber * synchedAt;
@end

@interface FLTAccount : NSObject
@property(nonatomic, strong, nullable) NSNumber * profileNeedsAgreement;
@property(nonatomic, strong, nullable) FLTProfile * profile;
@property(nonatomic, strong, nullable) NSNumber * isEmailVerified;
@property(nonatomic, strong, nullable) NSNumber * isEmailValid;
@property(nonatomic, strong, nullable) NSNumber * emailNeedsAgreement;
@property(nonatomic, copy, nullable) NSString * email;
@property(nonatomic, strong, nullable) NSNumber * isKakaotalkUser;
@property(nonatomic, strong, nullable) NSNumber * phoneNumberNeedsAgreement;
@property(nonatomic, copy, nullable) NSString * phoneNumber;
@property(nonatomic, strong, nullable) NSNumber * ageRangeNeedsAgreement;
@property(nonatomic, copy, nullable) NSString * ageRange;
@property(nonatomic, strong, nullable) NSNumber * birthdayNeedsAgreement;
@property(nonatomic, copy, nullable) NSString * birthday;
@property(nonatomic, strong, nullable) NSNumber * birthyearNeedsAgreement;
@property(nonatomic, copy, nullable) NSString * birthyear;
@property(nonatomic, strong, nullable) NSNumber * genderNeedsAgreement;
@property(nonatomic, copy, nullable) NSString * gender;
@property(nonatomic, strong, nullable) NSNumber * ciNeedsAgreement;
@property(nonatomic, copy, nullable) NSString * ci;
@property(nonatomic, strong, nullable) NSNumber * ciAuthenticatedAt;
@property(nonatomic, strong, nullable) NSNumber * legalNameNeedsAgreement;
@property(nonatomic, copy, nullable) NSString * legalName;
@property(nonatomic, strong, nullable) NSNumber * legalGenderNeedsAgreement;
@property(nonatomic, copy, nullable) NSString * legalGender;
@property(nonatomic, copy, nullable) NSString * legalBirthDate;
@end

@interface FLTProfile : NSObject
@property(nonatomic, copy, nullable) NSString * nickname;
@property(nonatomic, copy, nullable) NSString * profileImageUrl;
@property(nonatomic, copy, nullable) NSString * thumbnailImageUrl;
@end

@protocol FLTKakaoLoginApi
-(void)initialize:(FLTInitializeRequest*)input error:(FlutterError *_Nullable *_Nonnull)error;
-(nullable FLTOAuthToken *)currentToken:(FlutterError *_Nullable *_Nonnull)error;
-(nullable FLTGetHashKeyReply *)getHashKey:(FlutterError *_Nullable *_Nonnull)error;
-(void)accessTokenInfo:(void(^)(FLTAccessTokenInfo *_Nullable, FlutterError *_Nullable))completion;
-(nullable FLTBoolReply *)isKakaoTalkLoginAvailable:(FlutterError *_Nullable *_Nonnull)error;
-(void)logout:(void(^)(FLTVoidReply *_Nullable, FlutterError *_Nullable))completion;
-(void)unlink:(void(^)(FLTVoidReply *_Nullable, FlutterError *_Nullable))completion;
-(void)login:(void(^)(FLTOAuthToken *_Nullable, FlutterError *_Nullable))completion;
-(void)logInWithKakaoTalk:(void(^)(FLTOAuthToken *_Nullable, FlutterError *_Nullable))completion;
-(void)logInWithKakaoAccount:(void(^)(FLTOAuthToken *_Nullable, FlutterError *_Nullable))completion;
-(void)me:(void(^)(FLTUser *_Nullable, FlutterError *_Nullable))completion;
@end

extern void FLTKakaoLoginApiSetup(id<FlutterBinaryMessenger> binaryMessenger, id<FLTKakaoLoginApi> _Nullable api);

NS_ASSUME_NONNULL_END
